.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm			; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
LOOP_COUNT	= 100000		; 1000000 would be a typical value

parseFewJumps	PROTO: DWORD
parseTable	PROTO: DWORD
parseManyJumps	PROTO: DWORD
parseManyAhAl	PROTO: DWORD
parseElseif	PROTO: DWORD
parseSwitch	PROTO: DWORD
ShowCpu	PROTO:DWORD


results MACRO algo
LOCAL tmp$
	tmp$ CATSTR <print str$(eax), 9, "cycles for >, <algo>, <, ">
	tmp$
	@CatStr(<mov eax, >, <algo>, <_endp>)
	@CatStr(<sub eax, >, <algo>)
	print str$(eax), " bytes, #h="
	print str$(NumH), 13, 10
ENDM

PARSETABLE STRUCT
	TheChar	BYTE ?
	TheLabel	DWORD ?
PARSETABLE ENDS

.data
align 16
Src1	db "1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.5678h"
	db "1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.5678h"
	db "1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.5678h"
	db "1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.5678h"
	db "1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h", 0

align 16
Src2	db "1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h", 0

align 16
Src3	db "1234.567h", 0

.data?
NumH	dd ?
Dest	db 100 dup(?)

.code
start:
	invoke ShowCpu, 1
	sct = 0
	REPEAT 3
	sct=sct+1
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		@CatStr(<invoke parseTable, offset Src>, %sct)
	counter_end
	results parseTable

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		@CatStr(<invoke parseManyAhAl, offset Src>, %sct)
	counter_end
	results parseManyAhAl

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		@CatStr(<invoke parseFewJumps, offset Src>, %sct)
	counter_end
	results parseFewJumps

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		@CatStr(<invoke parseManyJumps, offset Src>, %sct)
	counter_end
	results parseManyJumps

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		@CatStr(<invoke parseElseif, offset Src>, %sct)
	counter_end
	results parseElseif

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		@CatStr(<invoke parseSwitch, offset Src>, %sct)
	counter_end
	results parseSwitch
	print chr$(13, 10)
	ENDM

	inkey chr$("--- ok ---", 13)
	exit

parseFewJumps proc uses esi Src:DWORD
		and NumH, 0
		mov esi, Src
		jmp @F
		HasE:
		jmp @F
		HasDot:
		jmp @F
		HasH:
		inc NumH
		jmp @F
		HasB:
		jmp @F
		HasY:
		jmp @F
		HasB1:
		jmp @F
		HasB2:
		@@:
			mov al, [esi]
			inc esi
			.if al<"0" || al>"9"	; few jumps
				test al, al
				je @F
				or al, 20h
				cmp al, "e"
				je HasE
				cmp al, "."
				je HasDot
				cmp al, "h"
				je HasH
				cmp al, "b"
				je HasB
				cmp al, "y"
				je HasY
				cmp al, "("
				je HasB1
				cmp al, "("
				je HasB2
			.endif
		jmp @B
		@@:
		ret
parseFewJumps endp
parseFewJumps_endp:

parseTable proc uses esi edi Src:DWORD
		plCTS1:
		.data?
	ChTable	dd 256 dup(?)	; CHARTABLE parser
	.data
	pt PARSETABLE <0, plCTE1>,	; if nullbyte found, jump out of the loop
	<"e", ChkE>, <"E", ChkE>,	; exponent, lowercase or uppercase
	<".", ChkDot>,
	<"h", ChkH>, <"H", ChkH>,	; hex
	<"b", ChkB>, <"B", ChkB>,	; binary
	<"y", ChkY>, <"Y", ChkY>,	; binary
	<"(", ChkB1>, <")", ChkB2>	; brackets
	ptEnd db -128		; flag end of table
		.code
		and NumH, 0		; first instruction for all algos
		mov esi, Src
		mov edi, offset ChTable
		cmp dword ptr [edi], 0
		jne plCT0
		mov ecx, 256	; this part will be run only once, so it can be slow
		push edi
		mov eax, plCT	; set defaults
		rep stosd
		pop edi
		push esi
		mov esi, offset pt
		.Repeat
			lodsb
			.Break .if al==-128
			movzx edx, al
			lodsd
			mov [edi+4*edx], eax
		.Until 0
		pop esi
		jmp plCT0

		ChkE:
		jmp plCT
		ChkDot:
		jmp plCT
		ChkH:
		inc NumH
		jmp plCT
		ChkB:
		jmp plCT
		ChkY:
		jmp plCT
		ChkB1:
		jmp plCT
		ChkB2:
	plCT0:
		xor eax, eax
	plCT:
		movzx eax, byte ptr [esi]
		inc esi
		; now jump to the address obtained from the table
		if 0
			jmp dword ptr [ChTable+4*eax]		; slowest
		elseif 1
			mov eax, [edi+4*eax]					; fastest
			jmp eax
		else
			jmp dword ptr [edi+4*eax]			; fast
		endif

	plCTE1:
	ret
parseTable endp
parseTable_endp:

parseManyJumps proc uses esi Src:DWORD
		S2:
		and NumH, 0		; first instruction for all algos
		mov esi, Src
		@@:
			mov al, [esi]
			inc esi
			.if al<"0" || al>"9"	; many jumps
				test al, al
				je @F
				or al, 20h
				.if al=="e"
					jmp @B
				.endif
				.if al=="."
					jmp @B
				.endif
				.if al=="h"
					inc NumH
					jmp @B
				.endif
				.if al=="b"
					jmp @B
				.endif
				.if al=="y"
					jmp @B
				.endif
				.if al=="("
					jmp @B
				.endif
				.if al==")"
					jmp @B
				.endif
			.endif
		jmp @B
		@@:
		ret
parseManyJumps endp
parseManyJumps_endp:

parseManyAhAl proc uses esi Src:DWORD
		and NumH, 0		; first instruction for all algos
		mov esi, Src
		@@:
			movzx eax, word ptr [esi]
			inc esi
			.if al>="0" && al<="9"
				mov al, ah
				inc esi
			.endif
			.if al<"0" || al>"9"	; many jumps
				test al, al
				je @F
				or al, 20h
				.if al=="e"
					jmp @B
				.endif
				.if al=="."
					jmp @B
				.endif
				.if al=="h"
					inc NumH
					jmp @B
				.endif
				.if al=="b"
					jmp @B
				.endif
				.if al=="y"
					jmp @B
				.endif
				.if al=="("
					jmp @B
				.endif
				.if al=="("
					jmp @B
				.endif
			.endif
		jmp @B
		@@:
		ret
parseManyAhAl endp
parseManyAhAl_endp:

parseElseif proc uses esi Src:DWORD
		and NumH, 0		; first instruction for all algos
		mov esi, Src
		@@:
			mov al, [esi]
			inc esi
			.if al<"0" || al>"9"	; many jumps
				test al, al
				je @F
				or al, 20h
				.if al=="e"
					jmp @B
				.elseif al=="."
					jmp @B
				.elseif al=="h"
					inc NumH
					jmp @B
				.elseif al=="b"
					jmp @B
				.elseif al=="y"
					jmp @B
				.elseif al=="("
					jmp @B
				.elseif al=="("
					jmp @B
				.endif
			.endif
		jmp @B
		@@:
		ret
parseElseif endp
parseElseif_endp:

parseSwitch proc uses esi Src:DWORD
		and NumH, 0		; first instruction for all algos
		mov esi, Src
		@@:
			movzx eax, byte ptr [esi]
			inc esi
			.if al<"0" || al>"9"
				or al, 20h
				SWITCH eax
				CASE 20h
				jmp @F
				CASE "e"
				CASE "."
				CASE "h"
					inc NumH
				CASE "b"
				CASE "y"
				CASE "("
				CASE ")"
				ENDSW
			.endif
		jmp @B
		@@:
		ret
parseSwitch endp
parseSwitch_endp:

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
ShowCpu proc mode:DWORD
COMMENT	@ Usage: 
Move this line up:
ShowCpu	PROTO:DWORD
	invoke ShowCpu, 0		; simple, no printing, just returns SSE level
	invoke ShowCpu, 1		; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]